# Copyright (c) 2000-2008, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section   free

Name:           sablecc
Version:        3.2
Release:	2%{?dist}
Epoch:          0
Summary:        Sable Research Group's Compiler Compiler
License:        LGPL
URL:            http://www.sablecc.org/
Source0:        http://dl.sourceforge.net/sourceforge/sablecc/sablecc-3.2-src.tar.gz
Source1:        %{name}.sh
Source2:        http://repo1.maven.org/maven2/sablecc/sablecc/3.2/sablecc-3.2.pom
Patch0:         %{name}-build.patch
Group:          Development/Compilers
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

BuildArch:      noarch
BuildRequires:  jpackage-utils >= 0:1.7.4
BuildRequires:  java-devel = 0:1.5.0
BuildRequires:  ant >= 1.6.5
Requires:       jpackage-utils >= 0:1.7.4
Requires:       java >= 0:1.5.0

Requires(post):   jpackage-utils >= 0:1.7.4
Requires(postun): jpackage-utils >= 0:1.7.4

%description
SableCC is an object-oriented framework that generates compilers (and
interpreters) in the Java programming language. This framework is based
on two fundamental design decisions. Firstly, the framework uses
object-oriented techniques to automatically build a strictly typed
abstract syntax tree that matches the grammar of the compiled language
and simplifies debugging. Secondly, the framework generates tree-walker
classes using an extended version of the visitor design pattern which
enables the implementation of actions on the nodes of the abstract
syntax tree using inheritance. These two design decisions lead to a tool
that supports a shorter development cycle for constructing compilers.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Requires(post):   /bin/rm,/bin/ln
Requires(postun): /bin/rm

%description javadoc
%{summary}.

%prep
%setup -q 
%patch0 -b .sav0

%build
export JAVA_HOME=%{_jvmdir}/java-1.5.0
ant jar javadoc

%install
rm -rf $RPM_BUILD_ROOT
install -Dpm 644 lib/%{name}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
ln -s %{name}-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}.jar
install -Dm 755 %{SOURCE1} $RPM_BUILD_ROOT%{_bindir}/%{name}

# poms
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 644 %{SOURCE2} \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom
%add_to_maven_depmap %{name} %{name} %{version} JPP %{name}

install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(-,root,root,-)
%doc AUTHORS ChangeLog COPYING-LESSER LICENSE README.html THANKS
%{_bindir}/*
%{_javadir}/*
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}

%files javadoc
%defattr(-,root,root,-)
%doc %{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%changelog
* Mon Dec 08 2008 Will Tatam <will.tatam@red61.com> 3.2-2
- Auto rebuild for JPackage 5 in mock

* Tue Apr 22 2008 Ralph Apel <r.apel at r-apel.de> - 0:3.2-1jpp
- 3.2 for JPP-5.0

* Fri Sep 03 2004 Fernando Nasser <fnasser@redhat.com> - 0:2.18.2-2jpp
- Rebuild with Ant 1.6.2

* Mon Jun  7 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:2.18.2-1jpp
- Update to 2.18.2.

* Sat Oct 11 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:2.18.1-1jpp
- Update to 2.18.1.
- Include startup script.
- Fix Group tag.

* Fri Apr 12 2003 David Walluck <david@antti-microsoft.org> 0:2.18.0-2jpp
- fix Vendor tag and add Distribution tag

* Fri Apr 11 2003 David Walluck <david@anti-microsoft.org> 0:2.18.0-1jpp
- 2.18.0

* Wed Jan 23 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 2.16.2-2jpp
- macro section

* Tue Jan 8 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 2.16.2-1jpp
- first jpp release
